[tox]
env_list = yamllint,flake8,isort,yapf,pylint,build,pytest

[testenv:yamllint]
deps =
    -cconstraints.txt
    yamllint
constrain_package_deps = true
skip_install = True
commands = yamllint -s \
    ksy

[testenv:flake8]
deps =
    -cconstraints.txt
    flake8
    flake8-quotes
constrain_package_deps = true
skip_install = True
commands = {env_bin_dir}/flake8 . \
    satnogsdecoders/decoder/__init__.py

[testenv:isort]
deps =
    -cconstraints.txt
    isort
constrain_package_deps = true
commands = {env_bin_dir}/isort -c --df . \
    satnogsdecoders/decoder/__init__.py

[testenv:isort-apply]
deps =
    -cconstraints.txt
    isort
constrain_package_deps = true
commands = {env_bin_dir}/isort . \
    satnogsdecoders/decoder/__init__.py

[testenv:yapf]
deps =
    -cconstraints.txt
    yapf
constrain_package_deps = true
skip_install = True
commands = {env_bin_dir}/yapf -d -r . \
    satnogsdecoders/decoder/__init__.py

[testenv:yapf-apply]
deps =
    -cconstraints.txt
    yapf
constrain_package_deps = true
skip_install = True
commands = {env_bin_dir}/yapf -i -r .

[testenv:pylint]
deps =
    -cconstraints.txt
    pylint
    pytest
constrain_package_deps = true
commands = {env_bin_dir}/pylint \
    tests \
    {env_site_packages_dir}/satnogsdecoders \
    {env_site_packages_dir}/satnogsdecoders/decoder/__init__.py

[testenv:build]
deps =
     -cconstraints.txt
     build
constrain_package_deps = true
skip_install = True
commands =
    python -m build

[testenv:pytest]
deps =
    -cconstraints.txt
    pytest
constrain_package_deps = true
commands = {env_bin_dir}/pytest

[testenv:upload]
set_env =
    TWINE_USERNAME={env:PYPI_USERNAME}
    TWINE_PASSWORD={env:PYPI_PASSWORD}
deps =
    -cconstraints.txt
    build
    twine
constrain_package_deps = true
skip_install = True
commands =
    python -m build
    {env_bin_dir}/twine upload dist/*

[testenv:deps]
recreate = True
deps =
    -rrequirements-dev.txt
constrain_package_deps = true
commands = pip check
system_site_packages = true
